//+------------------------------------------------------------------+
//|                                                      3c_MACD.mq4 |
//|               MACD:  Copyright  2004, MetaQuotes Software Corp. |
//|                                       http://www.metaquotes.net/ |
//|             3color:  Copyright  2005,          Nikolay Kositsin |
//+------------------------------------------------------------------+
#property  copyright "Copyright  2004, MetaQuotes Software Corp."
#property  link      "http://www.metaquotes.net/"
//---- indicator settings
#property  indicator_separate_window
#property  indicator_buffers 5
#property  indicator_color1  Blue
#property  indicator_color2  Magenta
#property  indicator_color3  Gray
#property  indicator_color4  LimeGreen
#property  indicator_color5  DarkSlateBlue
//---- indicator parameters
extern int FastEMA=12;
extern int SlowEMA=26;
extern int SignalSMA=9;
extern int CountBars=300;
extern int Line=3;
//---- indicator buffers
double     Ind_buffer1[];
double     Ind_buffer2[];
double     Ind_buffer3[];
double     Ind_buffer4[];
double     MACD[];

double trend,Rezalt;
double Zml;
double Color1;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
  
//---- indicator buffers mapping
   IndicatorBuffers(4);
   if(!SetIndexBuffer(0,Ind_buffer1) &&
      !SetIndexBuffer(1,Ind_buffer2) &&
      !SetIndexBuffer(2,Ind_buffer3) &&
      !SetIndexBuffer(3,Ind_buffer4) &&
      !SetIndexBuffer(4,MACD))
       Print("cannot set indicator buffers!");
//---- drawing settings
    
   Color1= C'128,0,255';                                            
   SetIndexStyle(0,DRAW_HISTOGRAM, STYLE_SOLID, 3, Color1); 
   SetIndexStyle(1,DRAW_HISTOGRAM, STYLE_SOLID, 3);
   SetIndexStyle(2,DRAW_HISTOGRAM, STYLE_SOLID, 3);
   SetIndexStyle(3,DRAW_LINE, STYLE_DASHDOTDOT,1);   

   SetIndexDrawBegin(0,Bars-CountBars);
   SetIndexDrawBegin(1,Bars-CountBars);
   SetIndexDrawBegin(2,Bars-CountBars);
   SetIndexDrawBegin(3,Bars-CountBars+SignalSMA); 
     
   IndicatorDigits(MarketInfo(Symbol(),MODE_DIGITS)+1);

//---- name for DataWindow and indicator subwindow label
   IndicatorShortName("MACD("+FastEMA+","+SlowEMA+","+SignalSMA+")");
   SetIndexLabel(0,"MACDUp");
   SetIndexLabel(1,"MACDDown");
   SetIndexLabel(2,"MACDStr");
   SetIndexLabel(3,"Signal");
//---- initialization done
   return(0);
  }
//+------------------------------------------------------------------+
//| Moving Averages Convergence/Divergence                           |
//+------------------------------------------------------------------+
int start()   
   {
//---- drawing settings
   int limit;  
   int counted_bars=IndicatorCounted(); 
//---- check for possible errors
   if(counted_bars<0) return(-1);
//---- last counted bar will be recounted
   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;
//---- macd counted in the 1-st buffer
   
   for(int bar=0; bar<limit; bar++)      
   
      Rezalt=iMA(NULL,0,FastEMA,0,MODE_EMA,PRICE_CLOSE,bar)-iMA(NULL,0,SlowEMA,0,MODE_EMA,PRICE_CLOSE,bar);      
      
//---- Three Colour MACD mapping 
     for(bar=0; bar<limit; bar++)
   {          
       MACD[bar]=Rezalt;     
     
  //---- +SSSSSSSSSSSSSSSS <<< Three colore code >>> SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS+
  trend=Rezalt-MACD[bar+1];     
  if(trend>0.0)     {Ind_buffer1[bar]=Rezalt; Ind_buffer2[bar]=0.0;    Ind_buffer3[bar]=0.0;}
  else{if(trend<0.0){Ind_buffer1[bar]=0.0;    Ind_buffer2[bar]=Rezalt; Ind_buffer3[bar]=0.0;}
  else              {Ind_buffer1[bar]=0.0;    Ind_buffer2[bar]=0.0;    Ind_buffer3[bar]=Rezalt;}}    
  //---- +SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS+
 //---- 
   } 
        
//---- signal line counted in the 2-nd buffer
   for(bar=0; bar<limit; bar++)
      Ind_buffer4[bar]=iMAOnArray(MACD,Bars,SignalSMA,0,MODE_SMA,bar);
//---- done
   return(0);
  }